jQuery(function($) {
  
  "use strict";
  let megaMenuData = MegaMenuSettings.data;
  let megaMenuOptions = {};

  jQuery.ajax({
    method: 'POST',
    url: MegaMenuSettings.ajaxurl,
    data: {
        action: 'wpm_megamenu_get_settings',
    }
  }).done(function(response) {
      megaMenuOptions = JSON.parse(response);
      handleMegaMenu(megaMenuOptions);
  });

  function handleMegaMenu(options) {
    let active = options['activateMegaMenu'];
    let trigger = options['megaMenuTrigger'] == "hover" ? "mouseover" : "click";
    let fullwidth = options['megaMenuFullWidth'];
    let topSpacing = parseInt(options['megaMenuTopSpacing']);

    if (!active) {
      return;
    }
    
    for (let menu of megaMenuData) {
      if (fullwidth) {
        $('header#brx-header').append(menu);
      } else {
        $('header#brx-header ul').append(menu);
      }
    }

    $('.bricks-nav-menu-wrapper li.menu-item').on('mouseover', function() {
      if (options['megaMenuTrigger'] == "hover") {
        let megaMenus = $('.wpm-mega-menu');
        megaMenus.each(function() {
          let megaMenu = $(this);
          megaMenu.fadeOut();
        })
      }
    });
    
    $('.bricks-nav-menu-wrapper li.menu-item').on(trigger, function(e) {
      
      let navElement = $(this).attr("id");
      let megaMenus = $('.wpm-mega-menu');

      megaMenus.each(function() {
        let megaMenu = $(this);

        if (fullwidth) {
          megaMenu.css('top', megaMenu.closest('header').height() + topSpacing);
        } else {
          megaMenu.css('top', topSpacing + "px");
        }
  
        if (navElement == megaMenu.data('nav-item')) {

          e.preventDefault();

          if (megaMenu.hasClass('megamenu-open') && trigger == "click") {
            megaMenu.fadeOut();
            megaMenu.removeClass('megamenu-open');
            return;
          }

          megaMenu.fadeIn();
          megaMenu.addClass('megamenu-open');
        } else {
          megaMenu.fadeOut();
          megaMenu.removeClass('megamenu-open');
        }
  
      });
    });

    $('main').on('click', function() {
      let megaMenus = $('.wpm-mega-menu');
      megaMenus.each(function() {
        let megaMenu = $(this);
        megaMenu.fadeOut();
      })
    });
  }
});